function PC_Dimmer() {}

PC_Dimmer.init = function(id) {	// called when the MIDI device is opened & set up
	PC_Dimmer.id = id;	// Store the ID of this device for later use
	PC_Dimmer.directoryMode = false;
  PC_Dimmer.deckaktuell = 0;
	PC_Dimmer.fadersperre = false;
	PC_Dimmer.CrossfaderChangeSperreTimer = [-1, -1];
	PC_Dimmer.volumebeat = false;
	PC_Dimmer.volumebeatsperre = false;
	PC_Dimmer.VolumeBeatSperreTimer = [-1, -1];
	
	engine.connectControl("[Channel1]", "beat_active", "PC_Dimmer.Deck1BeatOutputToMidi");
	engine.connectControl("[Channel2]", "beat_active", "PC_Dimmer.Deck2BeatOutputToMidi");
	engine.connectControl("[Channel1]", "playposition", "PC_Dimmer.Deck1PostionChange");
	engine.connectControl("[Channel2]", "playposition", "PC_Dimmer.Deck2PostionChange");
	engine.connectControl("[Master]", "crossfader", "PC_Dimmer.CrossfaderChange");
	engine.connectControl("[Channel1]", "volume", "PC_Dimmer.Deck1VolumeChange");
	engine.connectControl("[Channel2]", "volume", "PC_Dimmer.Deck2VolumeChange");
}

PC_Dimmer.shutdown = function(id) {	// called when the MIDI device is closed
}

PC_Dimmer.Deck1VolumeChange = function() { //Decklaustaerke wurde geaendert
  if (PC_Dimmer.volumebeat == false) { // reaus wenn Volumebeat deaktiviert ist
		return;
	}
  if (PC_Dimmer.volumebeatsperre == true) { // reaus wenn Sperre aktiviert ist
		return;
	}
	// Aktuelle Volumewerte der Decks holen
	deck1volume = engine.getValue("[Channel1]", "volume");
	deck2volume = engine.getValue("[Channel2]", "volume");
	if (deck1volume == deck2volume) { // raus wenn Volume gleich ist
		return;
	}
	// Aktuelles Deck ermitteln
	var deck = 0; 
	if (deck2volume > deck1volume) { // Deck2 Volume ist groesser
		deck = 1;
	}
	// Schauen ob das Deck gewechselt hat
	if (deck != PC_Dimmer.deckaktuell){
		PC_Dimmer.deckaktuell = deck;
		midi.sendShortMsg(0x90,0x30,0x64+deck);   // Note C an mit 64 und Deck dazu addiert
		PC_Dimmer.volumebeatsperre = true;
		PC_Dimmer.VolumeBeatSperreTimer = engine.beginTimer(1000,"PC_Dimmer.VolumeBeatSperre()");
	}
}

PC_Dimmer.Deck2VolumeChange = function() { //Decklaustaerke wurde geaendert
  if (PC_Dimmer.volumebeat == false) { // reaus wenn Volumebeat deaktiviert ist
		return;
	}
  if (PC_Dimmer.volumebeatsperre == true) { // reaus wenn Sperre aktiviert ist
		return;
	}
	// Aktuelle Volumewerte der Decks holen
	deck1volume = engine.getValue("[Channel1]", "volume");
	deck2volume = engine.getValue("[Channel2]", "volume");
	if (deck1volume == deck2volume) { // raus wenn Volume gleich ist
		return;
	}
	// Aktuelles Deck ermitteln
	var deck = 0; 
	if (deck2volume > deck1volume) { // Deck2 Volume ist groesser
		deck = 1;
	}
	// Schauen ob das Deck gewechselt hat
	if (deck != PC_Dimmer.deckaktuell){
		PC_Dimmer.deckaktuell = deck;
		midi.sendShortMsg(0x90,0x30,0x64+deck);   // Note C an mit 64 und Deck dazu addiert
		PC_Dimmer.volumebeatsperre = true;
		PC_Dimmer.VolumeBeatSperreTimer = engine.beginTimer(1000,"PC_Dimmer.VolumeBeatSperre()");
	}
}

PC_Dimmer.VolumeBeatSperre = function() { // eine Sekunde Deckwechsel verhindern
	engine.stopTimer(PC_Dimmer.VolumeBeatSperreTimer);
	PC_Dimmer.volumebeatsperre = false;
	midi.sendShortMsg(0x90,0x30,0x0);   // Note C an mit 0
	midi.sendShortMsg(0x80,0x30,0x0);   // Note C off mit 0
	PC_Dimmer.Deck1VolumeChange();      // Schauen ob Deck noch aktuell ist
}

PC_Dimmer.VolumeBeatOnVerzoegerung = function() { // Deckwechsel mit Deckvolume erst nach drei Sekunden erlauben
	engine.stopTimer(PC_Dimmer.VolumeBeatOnVerzoegerungTimer);
	PC_Dimmer.volumebeat = true;
}

PC_Dimmer.CrossfaderChange = function() { // Crossfader wurde bewegt, Deck pruefen;
	// Falls Fadersperre, gleich raus
	if (PC_Dimmer.fadersperre == true) {
		return;
	}

  // Pruefe Umstellung Decksteuerung auf Volume-Deck
  PC_Dimmer.volumebeat = false;
	engine.stopTimer(PC_Dimmer.VolumeBeatOnVerzoegerungTimer);
	if (engine.getValue("[Master]", "crossfader") > -0.25) { // Fader ist 25% links von Null;
    if (engine.getValue("[Master]", "crossfader") < 0.25) { // Fader ist 25% lin von Null;
      //PC_Dimmer.volumebeat = true;
      PC_Dimmer.VolumeBeatOnVerzoegerungTimer = engine.beginTimer(3000,"PC_Dimmer.VolumeBeatOnVerzoegerung()");
		}
	}

	// Falls Fader in Mittelstellung, nichts machen und raus
	if (engine.getValue("[Master]", "crossfader") == 0) {
		return;
	}

	// Aktuelles Deck ermitteln, 0-Position = links
	var deck = 0; 
	if (engine.getValue("[Master]", "crossfader") > 0) { // Fader ist Rechts und nicht mittig
		deck = 1;
	}

	// Schauen ob das Deck gewechselt hat
	if (deck != PC_Dimmer.deckaktuell){
		PC_Dimmer.deckaktuell = deck;
		midi.sendShortMsg(0x90,0x30,0x64+deck);   // Note C an mit 64 und Deck dazu addiert
		PC_Dimmer.fadersperre = true;
		PC_Dimmer.CrossfaderChangeSperreTimer = engine.beginTimer(1000,"PC_Dimmer.CrossfaderChangeSperre()");
	}
}

PC_Dimmer.CrossfaderChangeSperre = function() { // eine Sekunde Deckwechsel verhindern
	engine.stopTimer(PC_Dimmer.CrossfaderChangeSperreTimer);
	PC_Dimmer.fadersperre = false;
	midi.sendShortMsg(0x90,0x30,0x0);   // Note C an mit 0
	midi.sendShortMsg(0x80,0x30,0x0);   // Note C off mit 0
	PC_Dimmer.CrossfaderChange();       // Schauen ob Deck noch aktuell ist
}

PC_Dimmer.Deck1PostionChange = function() { // Playposition hat sich geaendert
	if (PC_Dimmer.deckaktuell == 0) { // aktuelles Deck pruefen
		PC_Dimmer.SendMidiMtcFullframe("[Channel1]");
	}
}

PC_Dimmer.Deck2PostionChange = function() { // Playposition hat sich geaendert
	if (PC_Dimmer.deckaktuell == 1) { // aktuelles Deck pruefen
		PC_Dimmer.SendMidiMtcFullframe("[Channel2]");
	}
}

PC_Dimmer.SendMidiMtcFullframe = function(deck) { // Sendet einen MTC full Frame
	var fps = 2; // 2 = 25 FPS
	var PlayPositionRest = engine.getValue(deck, "duration") * engine.getValue(deck, "playposition");
	if (PlayPositionRest < 0) {
		PlayPositionRest = 0;
	}
	// Stunden-Position berechnen und von PlayPositionRest abziehen 
	var hr = Math.floor(PlayPositionRest / 3600);
	PlayPositionRest = PlayPositionRest - (hr * 3600);
	// Minuten-Position berechnen und von PlayPositionRest abziehen
	var mn = Math.floor(PlayPositionRest / 60);
	PlayPositionRest = PlayPositionRest - (mn * 60);
	// Sekunden-Position berechnen und von PlayPositionRest abziehen
	var ss = Math.floor(PlayPositionRest);
	PlayPositionRest = PlayPositionRest - ss;
	// Frame-Position berechnen und von PlayPositionRest abziehen
	var fr = Math.floor(PlayPositionRest * 25);
  // Sysex-Frame zusammensetzen und raus damit
	var fullframe = [0xf0,0x7f,0x7f,0x01,0x01,(16 * fps) + hr,mn,ss,fr,0xf7];
	midi.sendSysexMsg(fullframe,10);
}

PC_Dimmer.Deck1BeatOutputToMidi = function() { // Midi-Note senden bei Beatereignis
  var deckbpm = engine.getValue("[Channel1]", "bpm")-50;
  if (deckbpm <= 0) {
    deckbpm = 0;
  }
  if (deckbpm >= 127) {
    deckbpm = 127;
  }
  if (PC_Dimmer.deckaktuell == 0) { // raus wenn es nicht das aktuelle Deck ist
		if (engine.getValue("[Channel1]", "beat_active") == true ) { // Beat ist an, sende Note an
			midi.sendShortMsg(0x90,0x32,0x64);   // Note D an mit 64
			midi.sendShortMsg(0x90,0x34,deckbpm);   // Note E an mit BPM-Wert senden
		} else { // Beat ist aus, sende Note aus
			midi.sendShortMsg(0x90,0x32,0x0);   // Note D an mit 0
			midi.sendShortMsg(0x80,0x32,0x0);   // Note D off mit 0
		}
	}
}

PC_Dimmer.Deck2BeatOutputToMidi = function() { // Midi-Note senden bei Beatereignis
  var deckbpm = engine.getValue("[Channel2]", "bpm")-50;
  if (deckbpm <= 0) {
    deckbpm = 0;
  }
  if (deckbpm >= 127) {
    deckbpm = 127;
  }
  if (PC_Dimmer.deckaktuell == 1) { // raus wenn es nicht das aktuelle Deck ist
		if (engine.getValue("[Channel2]", "beat_active") == true ) { // Beat ist an, sende Note an
			midi.sendShortMsg(0x90,0x32,0x64);   // Note D an mit 64
			midi.sendShortMsg(0x90,0x34,deckbpm);   // Note E an mit BPM-Wert senden
		} else { // Beat ist aus, sende Note aus
			midi.sendShortMsg(0x90,0x32,0x0);   // Note D an mit 0
			midi.sendShortMsg(0x80,0x32,0x0);   // Note D off mit 0
		}
	}
}

// ----------- Beispiel & Source WWW
// http://mixxx.org/wiki/doku.php/midi_scripting  bei MyController.elapsedTime = function (deck) {
// http://mixxx.org/wiki/doku.php/mixxxcontrols
